unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, DXSound1, DSoundYK, ComCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
	GroupBox2: TGroupBox;
	Button1: TButton;
	Button3: TButton;
	Button4: TButton;
	Panel1: TPanel;
	Button2: TButton;
	Button6: TButton;
	TrackBar1: TTrackBar;
    TrackBar2: TTrackBar;
    TrackBarX: TTrackBar;
    TrackBarY: TTrackBar;
    TrackBarZ: TTrackBar;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
    procedure TrackBar2Change(Sender: TObject);
    procedure TrackBarXChange(Sender: TObject);
    procedure TrackBarYChange(Sender: TObject);
    procedure TrackBarZChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
  public
    // Direct Sound 
    DXSound       : TDirectSound;

	h2Dwave       : Integer;
	h3Dwave       : Integer;
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
begin
   // Direct Sound ü 
   DXSound := TDirectSound.Create(Handle);

{$IFDEF USE_RESOURCE}
   // Wav  ҽ   ̶, ҽ Ÿ 25 , 3D   
   // h2Dwave    wave   ڵ .
   h2Dwave := DXSound.LoadWaveResource(hInstance,'TEST',MakeIntResource(25),FALSE);
{$ELSE}
   h2Dwave := DXSound.LoadWave('Test2.Wav',FALSE);
{$ENDIF}

   // Wav  Ϸκ . 3D ۸ 
   // h3Dwave    wave   ڵ .
   h3Dwave := DXSound.LoadWave('Test1.Wav',TRUE);

   Panel1.Enabled  := TRUE;
   Button1.Enabled := FALSE;
   Button3.Enabled := TRUE;
   Button4.Enabled := TRUE;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
   // 2D 带 Ѵ.
   DXSound.Play(h2Dwave);
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
   //  µǴ wave 带  .
   DXSound.Stop(h3Dwave);
   DXSound.Stop(h2Dwave);
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
   // Direct Sound class ü ϰ ó ·  ´.
   DXSound.Free;
   DXSound := nil;

   Panel1.Enabled  := FALSE;
   Button1.Enabled := TRUE;
   Button3.Enabled := FALSE;
   Button4.Enabled := FALSE;
end;

var
   D3DPos : TD3DVECTOR;

procedure TForm1.Button6Click(Sender: TObject);
begin
   // 3D 带 Ѵ.
   DXSound.Play3D(h3Dwave, D3DPos);
end;

procedure TForm1.TrackBar1Change(Sender: TObject);
begin
   // 2D 忡   Ѵ.
   DXSound.Volume[h2Dwave] := TrackBar1.Position;
end;

procedure TForm1.TrackBar2Change(Sender: TObject);
begin
   // 2D 忡 Pan Ѵ.
   DXSound.Pan[h2Dwave] := TrackBar2.Position;
end;

procedure TForm1.TrackBarXChange(Sender: TObject);
begin
   // 3D 忡  X   Ÿ.
   D3DPos.x := TrackBarX.Position / 100;
   DXSound.Pos3D[h3Dwave] := D3DPos;
end;

procedure TForm1.TrackBarYChange(Sender: TObject);
begin
   // 3D 忡  Y   Ÿ.
   D3DPos.y := TrackBarY.Position / 100;
   DXSound.Pos3D[h3Dwave] := D3DPos;
end;

procedure TForm1.TrackBarZChange(Sender: TObject);
begin
   // 3D 忡  Z   Ÿ.
   D3DPos.z := TrackBarZ.Position / 100;
   DXSound.Pos3D[h3Dwave] := D3DPos;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
   Panel1.Enabled  := FALSE;
   Button1.Enabled := TRUE;
   Button3.Enabled := FALSE;
   Button4.Enabled := FALSE;
end;

end.


